#include <stdio.h>
#include <sys/acct.h>
#include <sys/tacct.h>

/*
 * These files: /var/adm/acct/nite/daytacct20050401 have a record length
 * of 72 bytes.
 * struct tacct has a length of 88
 * struct acct has a length of 96
 */

#define method 2

#if method == 0
#	define thestruct acct
#elif method == 1
#	define thestruct tacct
#elif method == 2
#	define thestruct mine
	struct mine {
		uid_t 
	};
int main(int argc,char *argv[])
	{
	int i;
#	define thestruct mine
#	if NEVER
#	define thestruct acct
#	define thestruct tacct
	fprintf(stderr,"acct: %d\n", sizeof(struct acct));
	fprintf(stderr,"tacct: %d\n", sizeof(struct tacct));
	fprintf(stderr,"number of files %d\n", argc);
#	endif
	return 0;
	for (i=1; i<argc; i++)
		{
		FILE *file;
		fprintf(stderr,"processing file %d %s\n", i, argv[i]);
		file=fopen(argv[i],"r");
		if (file != NULL)
			{
			int j;
			struct thestruct thestruct;
			char username[9];
			int numread;
#if NEVER
			/* these files appear to have some kind of 4 byte header on
			 * them - toast it
			 */
			for (j=0; j<4; j++)
				{
				fgetc(file);
				}
#else
			/* No, no, no.  That "header" is really the 4 byte uid! */
#endif
			for ( ; numread=fread((void *)&tacct,sizeof(struct thestruct),1,file); numread==1)
				{
				int k;
				if (numread == 0)
					{
					break;
					}
				for (k=0; k<8; k++)
					{
					username[k] = tacct.ta_name[k];
					username[8] = '\0';
					}
				printf("%d %s %f\n",tacct.ta_uid,username,tacct.ta_cpu);
				}
			}
		else
			{
			fprintf(stderr,"Could not open %s\n", argv[i]);
			}
		}
	return 0;
	}

#if NEVER

struct	tacct	{
	uid_t		ta_uid;		/* userid */
	char		ta_name[8];	/* login name */
	float           ta_cpu[2];      /* cum. cpu time (mins) */
	float           ta_kcore[2];    /* cum kcore-mins */
	float           ta_io[2];       /* cum. chars xferred (512s) */
	float           ta_rw[2];       /* cum. blocks read/written */
	float           ta_con[2];      /* cum. connect time (mins) */
	float		ta_du;		/* cum. disk usage */
	long            ta_qsys;        /* queueing sys charges (pgs) */
	float		ta_fee; 	/* fee for special services */
	long		ta_pc;		/* count of processes */
	unsigned short	ta_sc;		/* count of login sessions */
	unsigned short	ta_dc;		/* count of disk samples */
};

struct	acct
{
	char	ac_flag;		/* Accounting flag */
	char	ac_stat;		/* Exit status */
	char	ac_version;		/* File version */		
	char	ac_len;			/* Length of structure */
	uid_t	ac_uid;			/* Accounting user ID */
	gid_t	ac_gid;			/* Accounting group ID */
#ifdef __64BIT__
	dev32_t	ac_tty;			/* control typewriter */
	dev_t	ac_tty64;		/* 64-bit control typewriter */
#else
	dev_t	ac_tty;			/* control typewriter */
#if defined(_LONG_LONG)
	dev64_t	ac_tty64;		/* 64-bit control typewriter */
#else
        /* For 32-bit applications that do not define _LONG_LONG, this
         * will keep the size and offsets of the structure the same. However,
         * it will not work properly. However, since 32-bit apps should not
         * care about 64-bit devices, it will not make a difference. */
	quad ac_tty64;
#endif
#endif /* __64_BIT__ */
#if defined(_LONG_LONG)
        uint64_t ac_wlmkey;             /* WLM class identification */
#else
        quad     ac_wlmkey;		/* WLM class identification */
#endif

#if !defined __64BIT__ && (BYTE_ORDER == BIG_ENDIAN)
	uint	ac_btime_pad;		/* Beginning time (high word) */
#endif
	time_t	ac_btime;		/* Beginning time */
#if !defined __64BIT__ && (BYTE_ORDER == LITTLE_ENDIAN)
	uint	ac_btime_pad;		/* Beginning time (low word) */
#endif
	
	comp_t	ac_utime;		/* acctng user time in seconds */
	comp_t	ac_stime;		/* acctng system time in seconds */
	comp_t	ac_etime;		/* acctng elapsed time in seconds */
	comp_t	ac_mem;			/* memory usage */
	comp_t	ac_io;			/* chars transferred */
	comp_t	ac_rw;			/* blocks read or written */
	char	ac_comm[12];		/* command name */
	int 	reserved[8];
};	

#endif

